;*********************************************************************************************************
; Work out which 'command' we have received and issue the appropriate response

Interpret:
	movf	Cmd1, 0
	xorlw	0x01
	btfsc	STATUS, Z
	goto	Cmd1_was_01

	movf	Cmd1, 0
	xorlw	0x02
	btfsc	STATUS, Z
	goto	Respond_Appoint			; Appoint is single byte command

	IFDEF   SERIAL_OUTPUT
	movf	Cmd1, 0				; Rad = 0x18 (always?)
	xorlw	0x08
	btfsc	STATUS, Z
	goto	But_Release

	movf	Cmd1, 0
	xorlw	0x24
	btfsc	STATUS, Z
	goto	But_FF

	movf	Cmd1, 0
	xorlw	0x25
	btfsc	STATUS, Z
	goto	But_REV

	movf	Cmd1, 0
	xorlw	0x26
	btfsc	STATUS, Z
	goto	But_NextTrack

	movf	Cmd1, 0
	xorlw	0x27
	btfsc	STATUS, Z
	goto	But_PrevTrack

	movf	Cmd1, 0
	xorlw	0x28
	btfsc	STATUS, Z
	goto	But_NextDisk

	movf	Cmd1, 0
	xorlw	0x29
	btfsc	STATUS, Z
	goto	But_PrevDisk

	movf	Cmd1, 0
	xorlw	0x34
	btfsc	STATUS, Z
	goto	But_Repeat

	movf	Cmd1, 0
	xorlw	0x35
	btfsc	STATUS, Z
	goto	But_Shuffle

	movf	Cmd1, 0
	xorlw	0x36
	btfsc	STATUS, Z
	goto	But_Intro
	ENDIF

;	movf	Cmd1, 0			ArneH responds to this with some display things
;	xorlw	0x80			 - try out his responses
;	btfsc	STATUS, Z
;	goto	Cmd_

	movf	Cmd1, 0
	xorlw	0xb0
	btfsc	STATUS, Z
	goto	Cmd_SeekAbs

	movf	Cmd1, 0
	xorlw	0xf0
	btfsc	STATUS, Z
	goto	Cmd_SourceSelect

	goto	Cmd_Unkown			; Unkown command

;--------

Cmd1_was_01:
	movf	Cmd2, 0
	btfsc	STATUS, Z			; Check for 'Init'
	goto	BusReset; SystemSetup

	movf	Cmd2, 0
	xorlw	0x02				; Check for 'Anyone'
	btfsc	STATUS, Z
	goto	Respond_Anyone

	movf	Cmd2, 0
	xorlw	0x11				; Check for 'Alive'
	btfsc	STATUS, Z
	goto	Respond_Hello

	movf	Cmd2, 0
	xorlw	0x12				; Check for 'Ping'
	btfsc	STATUS, Z
	goto	Respond_Ping

	movf	Cmd2, 0
	xorlw	0x13				; Check for 'Slave Poll'
	btfsc	STATUS, Z
	goto	Respond_SlavePoll

	movf	Cmd2, 0
	xorlw	0x15				; Check for 'Master Poll'
	btfsc	STATUS, Z
	goto	Respond_MasterPoll

	goto	Cmd_Unkown			; Unkown command

;--------

Cmd_Unkown:
	goto	ReceiveBreak

;--------

; Button outputs, cause strings to appear on serial port

	IFDEF   SERIAL_OUTPUT
But_Release:
	movf	Cmd2, W				; Cmd2 is always 0x00 (?)
	btfss	STATUS, Z
	goto	But_Done			; skip following code if Cmd2 != 0
	bcf	TXPlayMode, TXPM_FF
	bcf	TXPlayMode, TXPM_REV
	goto	But_Done

But_FF:
	movf	Cmd2, W				; Cmd2 is always 0x01 (?)
	xorlw	0x01
	btfsc	STATUS, Z
	bsf	TXPlayMode, TXPM_FF
	goto	But_Done

But_REV:
	movf	Cmd2, W				; Cmd2 is always 0x01 (?)
	xorlw	0x01
	btfsc	STATUS, Z
	bsf	TXPlayMode, TXPM_REV
	goto	But_Done

But_NextTrack:
	movlw	1				; add 1 to TXTrackRel_B
	addwf	TXTrackRel_B, F
	goto	But_Done

But_PrevTrack:
	movlw	1				; subtract 1 from TXTrackRel_B
	subwf	TXTrackRel_B, F
	goto	But_Done

But_NextDisk:
;	movlw	(command_next_disk - command_start)
;bei Becker nicht genutzt (?)
	goto	But_Done

But_PrevDisk:
;	movlw	(command_previous_disk - command_start)
;bei Becker nicht genutzt (?)
	goto	But_Done

But_Repeat:
	btfss	Cmd2, 4				; bit4=1: on; =0: off
	bcf	TXPlayMode, TXPM_RPT
	btfsc	Cmd2, 4				; bit4=1: on; =0: off
	bsf	TXPlayMode, TXPM_RPT
	goto	But_Done

But_Shuffle:
	btfss	Cmd2, 4				; bit4=1: on; =0: off
	bcf	TXPlayMode, TXPM_RP
	btfsc	Cmd2, 4				; bit4=1: on; =0: off
	bsf	TXPlayMode, TXPM_RP
	goto	But_Done

But_Intro:
	btfss	Cmd2, 4				; bit4=1: on; =0: off
	bcf	TXPlayMode, TXPM_Intro
	btfsc	Cmd2, 4				; bit4=1: on; =0: off
	bsf	TXPlayMode, TXPM_Intro
	goto	But_Done

But_Done:
;	movwf	command_offset			; Select command 3 'PRV_LIST'

;	movlw	HIGH serial_command_table
;	movwf	PCLATH
;	call	serial_command_table		; Get first character to tx from Look-up table

;	movwf	TXREG
;	incf	command_offset, 1		; now points to first byte to be sent by interrupt

;	bsf	STATUS, RP0			; Select bank 1
;	bsf	PIE1, TXIE			; Enable TX interrupts
;	bcf	STATUS, RP0			; select bank 0

	goto	ReceiveBreak
	ENDIF

;--------

Cmd_SeekAbs:
	movf	MyId, 0				; Check it's the right ID
	subwf	Rad, 0
	btfss	STATUS, Z
	goto	ReceiveBreak			; Done, wait for next command

	movf	Data11, 0			; store Track number
	movwf	TXTrackNum

	bcf	INTCON, GIE			; interrupt service may call WritePrep too

	call	DB_WritePrep			;
	movlw	0x20	;0xc0
	movwf	INDF

	call	DB_WritePrep			; 
	movlw	0x13	;0x90
	movwf	INDF

	call	DB_WritePrep			; 0xc0
	movlw	0x62	;0xc9
	movwf	INDF

	call	DB_WritePrep			; 0xc0
	movlw	0x72	;0xca
	movwf	INDF

;	call	DB_WritePrep			; 
;	movlw	0x1e	;0x90
;	movwf	INDF

	movf	Cmd2, 0				; Disk number
	xorlw	0xba				; 0xba = don't change disk
	btfsc	STATUS, Z
	goto	Cmd_SeekAbs1

	movf	Cmd2, 0				; Lo nibble of Cmd2: new disk number
	andlw	0x0F
	movwf	TXDiskNum

	call	DB_WritePrep			; 
	movlw	0x30	;0x97
	movwf	INDF

	call	DB_WritePrep			; 
	movlw	0x83	;0x95
	movwf	INDF

	call	DB_WritePrep			; 
	movlw	0x93	;0xcd
	movwf	INDF

Cmd_SeekAbs1:
	call	DB_WritePrep			;
	movlw	0x20	;0xc0
	movwf	INDF

;	call	DB_WritePrep			; 
;	movlw	0x1e	;0x90
;	movwf	INDF

	bsf	INTCON, GIE

;	movlw	0x01				; Restart the display sequence
;	movwf	Display

	call	IssueSlaveBreak			; Issue slave break to cause display to 
						; appear quickly
	goto	ReceiveBreak

;--------

Cmd_SourceSelect:
	movf	MyId, 0				; Cmd2 carries ID of selected device
	subwf	Cmd2, 0
	btfsc	STATUS, Z
	goto	Cmd_SourceSelect1

	movlw	0x80				; Another device was selected
	movwf	State				; Set my state = Idle

	movf	DisplayW, 0			; Immediately stop attempting to display stuff
	movwf	DisplayR

	clrf	TXDiskNum			; Clear all key-press info
	clrf	TXTrackNum
	clrf	TXTrackRel
	clrf	TXPlayMode

	btfsc	PORTA, 1			; Is player running?
	goto	ReceiveBreak
	bsf	PORTA, 1			; Switch off attached player

	bsf	STATUS, RP0			; Store UserBuf0 to EEPROM
	clrf	EEADR
	bcf	STATUS, RP0
	movf	UserBuf0, W
	call	EEWrite
	bsf	INTCON, GIE			; EEWrite disables interrupts

	goto	ReceiveBreak

Cmd_SourceSelect1:
	clrf	State				; Cmd2 = MyId: set State = Playing

	IFDEF	SERIAL
	bcf	PORTA, 1;	bsf	PORTB, 3			; Enable CTS
			;	bsf	PortBCopy, 3
	ENDIF

	bcf	INTCON, GIE

	IF 0
	call	DB_WritePrep			; seek info
	movlw	0x2d
	movwf	INDF

	call	DB_WritePrep			; track name[0]
	movlw	0x61
	movwf	INDF

	call	DB_WritePrep			; track name[1]
	movlw	0x71
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1d
	movwf	INDF

	call	DB_WritePrep			; seek info
	movlw	0x2c
	movwf	INDF

	call	DB_WritePrep			; track name[0]
	movlw	0x60
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1c
	movwf	INDF

	call	DB_WritePrep			; track name[1]
	movlw	0x70
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1c
	movwf	INDF

	call	DB_WritePrep			; seek info
	movlw	0x2f
	movwf	INDF

	call	DB_WritePrep			; track name[0]
	movlw	0x63
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1f
	movwf	INDF

	call	DB_WritePrep			; track name[1]
	movlw	0x73
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1f
	movwf	INDF
	ENDIF

	IF 0
	call	DB_WritePrep			; seek info
	movlw	0x2e
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1e
	movwf	INDF

	call	DB_WritePrep			; track name[0]
	movlw	0x62
	movwf	INDF

	call	DB_WritePrep			; track name[1]
	movlw	0x72
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1e
	movwf	INDF
	ENDIF




Cmd_DispUpdateProc:
	call	DB_WritePrep			; seek info
	movlw	0x23	;0xc0
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x13	;0x90
	movwf	INDF

;	call	DB_WritePrep			; 0xc0
;	movlw	0x40	;0x95
;	movwf	INDF

	call	DB_WritePrep			; total time
	movlw	0x33	;0x97
	movwf	INDF

	call	DB_WritePrep			; disk name
	movlw	0x83	;0xcd
	movwf	INDF

	call	DB_WritePrep			; disk name
	movlw	0x93	;0xce
	movwf	INDF

	call	DB_WritePrep			; track name
	movlw	0x63	;0xc9
	movwf	INDF

	call	DB_WritePrep			; track name
	movlw	0x73	;0xca
	movwf	INDF

	call	DB_WritePrep			; current time
	movlw	0x1e	;0x91
	movwf	INDF

	bsf	INTCON, GIE

	call	IssueSlaveBreak			; Issue slave break to cause display to 
						; appear quickly
	goto	ReceiveBreak
